<?php
function createwherelikestring($simplesearch){  //for admins to filter the results on the admin page
	global $memberfields;
	$tablecount = count($memberfields);

	if($simplesearch and $simplesearch != ""){
		debugprint("Simple searching for $simplesearch");
		
		for ($i=0;$i<$tablecount;$i++){
			if(!$sqlwhere){
				$sqlwhere = " WHERE (";
			}else{
				$sqlwhere .= " or ";
			}
			$sqlwhere .= $memberfields[$i]." LIKE '%".$simplesearch."%'";  //search for string in all fields
		}
	}else{
		debugprint("Advanced search reached.");
		for ($i=0;$i<$tablecount;$i++){
			if($_POST["search".$memberfields[$i]]){
				if(!$sqlwhere){
					$sqlwhere = " WHERE (";
				}else{
					$sqlwhere .= " or ";
				}
				$sqlwhere .= $memberfields[$i]." LIKE '%".trim($_POST["search".$memberfields[$i]])."%'";
			}
		}
	}
	if($sqlwhere){
		$sqlwhere .= ')';  //else the 'and' operators wont have much effect
	}
	
	//sigh.  if they select category from the dropdown, have it search BOTH category 1 and 2.
	if($_POST["searchcategory"]){
		if(!$sqlwhere){
			$sqlwhere = " WHERE ";
		}else{
			$sqlwhere .= " and ";
		}
		$sqlwhere .= "(Category1 LIKE '%".$_POST["searchcategory"]."%' or Category2 LIKE '%".$_POST["searchcategory"]."%')";
	}

	$orderby = "";		
	if($_GET["orderby"]){  //they clicked on a sorting name
		if($_SESSION["prevwherestring"]){  //just resort the previous query
			$sqlwhere = $_SESSION["prevwherestring"];
		}

		$orderby .= " ORDER BY ".$_GET["orderby"];
		if($_SESSION["prevorderby"]){
			if ($_SESSION["prevorderby"] == $_GET["orderby"]){
				$orderby .= " DESC";
				$_SESSION["prevorderby"] = "";
			}else{
				$orderby .= ", ".$_SESSION["prevorderby"];
				$_SESSION["prevorderby"] = $_GET["orderby"];
			}
		}else{
			$_SESSION["prevorderby"] = $_GET["orderby"];
		}
	}else{
		$orderby .= " ORDER BY company,category1,category2";//default
	}
	
	$_SESSION["prevwherestring"] = $sqlwhere;

	return $sqlwhere.$orderby;
}


function createadvancedsearchfields($tablename="members",$showapproved=true){
	
	//echo "<form action='$PHP_SELF' method='post'>";
	global $memberfields;
	//debugprint("Memberfields");
	//debugprint ($memberfields);
	$tablecount = count($memberfields);
	echo "<table cellpadding=1 border=1>";
	echo "<tr>";
	$tablecount = count($memberfields);
	for ($i=0;$i<$tablecount;$i++){
		if(strtolower($memberfields[$i]) == "approved" && $showapproved === false) {
			continue;
		}
		echo "<td class='cramtofit'><b><font size='1'>$memberfields[$i]</font></b>
			<br>
			<input class='advancedsearch' type='text' name='search".$memberfields[$i]."' value = '".$_POST["search".$memberfields[$i]]."' /><br />			
		</td>";

	}
	echo "</tr>";
	echo "</table>";

//	</form>";
}


function wherestringtoresult($wherestring = ""){	
	
	debugprint("Searchcalled");
	
	$query = "
		SELECT * FROM members $wherestring
	";

	$result = sendquery($query);
	return $result;

}

function drawresult($array,$approvedoverride = false){  //this is what end users see
// $memberfields = array("firstname","lastname","company","category1","category2","phone","email","website","address1","address2","city","state","zip");
		
		$firstname = $array["firstname"];
		$lastname = $array["lastname"];
		$company = $array["company"];
		$category1 = $array["category1"];
		$category2 = $array["category2"];
		$phone = $array["phone"];
		$email = $array["email"];
		$website = $array["website"];
		$address1 = $array["address1"];
		$address2 = $array["address2"];
		$city = $array["city"];
		$state = $array["state"];
		$zip = $array["zip"];
		$businesslogo = $array["businesslogo"];
		$description = $array["description"];
		
		$approved = $array["approved"];
		$approved = strtoupper($approved);
		if((strtoupper($approved) != "TRUE") && (!$approvedoverride)){
			//not approved.  exit
			debugprint("NOT approved.");
			return false;
		}
	

		if($description or $businesslogo) {
			echo "<table class='searchresults' BORDER=2 CELLSPACING=0 CELLPADDING=5 width=100%><tr  class='searchresults' ><td  class='searchresults'  WIDTH=50%>";
		}else { 
			echo "<table class='searchresults'  BORDER=2 CELLSPACING=0 CELLPADDING=5 width=100%><tr  class='searchresults' ><td  class='searchresults' >";
		}

		if((!$company) and ($website)){
			$company = $website;
		}
		echo " 	
		<font size='+1' color='#000000' face='Verdana, Arial, Helvetica, sans-serif'> 
		<u>$company<br></u>
	    </font> <font  face='Arial, Helvetica, sans-serif'>";
		
		if($category1){
			echo "<li> $category1<br>";
		}
		if($category2){
			echo "<li> $category2<br>";
		}

		if($firstname){
			echo "<br><u>Contact Information</u>:<br>$firstname $lastname<br>";
		}
		if($phone){
			echo "$phone<br>";
		}
		if($email){
			echo "$email<br>";
		}
		
		if($website) {
			echo "<a href='http://".$website."' target='_blank'>$website</a><br>";
		}
		if($address1){
			echo "<br><u>Address</u>:<br>$address1, $address2<br>";
		}
		if($city){
			echo "$city, $state $zip<br>";
		}
		if($description or $businesslogo) {
			echo "</td><td>";
		}
		if($description){
			echo "<u><b>Description</b></u>:<br><i>$description</i><br><br>";
		}
		if($businesslogo and trim($businesslogo != "")) {
			echo "<a href='http://".$website."' target='_blank'><img src='http://".$businesslogo."' width=225></a>";
		}
		if($description or $businesslogo) {
			echo "</td></tr></table>";
		}
		else echo"
				</td></tr></table>
				</font>
	
		";
// Trying to make it so there are no gaps when information is missing.	
		
}


function addmember(){
	global $memberfields;
	$fieldcount = count($memberfields);
	for ($i=0;$i<$fieldcount;$i++){
		if(trim($_POST["search".$memberfields[$i]]) != ""){  //if its not empty
			if(!$query){//first line
				$query = "INSERT INTO members SET ";
				$query .= $memberfields[$i]."='". $_POST["search".$memberfields[$i]]."' ";
			}else{
				$query .= ", ".$memberfields[$i]."='". $_POST["search".$memberfields[$i]]."' ";			
			}
		}
	}
	sendquery($query);
	$_POST=array();  //clear it and show all results
}





function create_tables() {
	global $memberfields;
	debugprint("Create tables() ");
	//create db fields if dont exist
	addcolstotable($memberfields,"members");
	
	return true;
}


function addcolstotable($columns,$table){
	$tablecount = count($columns);  
	echo "<tr>";
	
	$query1 = "SHOW COLUMNS FROM ".$table;
	$result1 = sendquery($query1);

	//debugprint("addcolstotable.  count=".$tablecount);
	//debugprint($result1);

	if($result1){//table exists
		$existingfields = array();
		while($columnnames = mysql_fetch_row($result1)) {
			$existingfields[] = $columnnames[0];
		}
		
		for ($i=0;$i<$tablecount;$i++){
			if(!in_array($columns[$i],$existingfields)){
				$query = "ALTER IGNORE TABLE $table ADD $columns[$i] VARCHAR(600)";		
				sendquery($query);
			}
		}
	}else{
		$query="CREATE TABLE IF NOT EXISTS $table 
		
		(";
		
		for ($i=0;$i<$tablecount;$i++){
			$query .= $columns[$i]." VARCHAR(1000),";  //that should cover all eventualities :)
		}
		
		//$query .= "	test VARCHAR(1000)	)";
		$query .= "	ID INT NOT NULL AUTO_INCREMENT PRIMARY KEY	)";
		
		//$query .= " CHARACTER SET utf32 ;";  //didn't fix not allowing single right quote inserts :(
		$query .= ";";
		if(sendquery($query)){
			//try again - If creating tables is not allowed it will  infinite  :(
			addcolstotable($columns,$table);
		}else{
			debugprint( "Error in ".__LINE__." ".__FUNCTION__." could not create table");
			global $SETTINGS;
			debugprint($SETTINGS);
		//	phpinfo();
		}
		
	}
}


?>