<html>
<?php
function var_to_str($in){
   if(is_bool($in))
   {
      if($in)
         return "true";
      else
         return "false";
   }
   else
      return $in;
}
function str_to_bool($in){
	if( strtolower($in) == "true"){
		return true;
	}elseif( strtolower($in) == "false"){
		return false;
	}else{
		return $in;
	}
}

$printstack = -1;  //increment with each iteration, to format print better
function debugprint($message,$inline = false){
//	echo "debugprint start";
	global $printstack;
	global $SETTINGS;  //this is different from C, thats why

	if (isset($SETTINGS["debug"]) and (var_to_str($SETTINGS["debug"]) == "true")) {  //why the bloody hell isn't this working
		$printstack++;
		if(!$inline){
			echo "<br>";
//			echo "(type: ".gettype($message).") ";
		}
		$filler = str_repeat(". . ",$printstack);
		echo $filler;
				
		if (is_resource($message)){
			while($row = mysql_fetch_row($message)) {
				echo "query result:";
//				print("query result");
				debugprint($row);
			}
			
		}elseif(is_array($message)){
			echo "  Array of ".count($message);
			foreach ($message as $key => $value){
				debugprint( "[".$key."] = ");
				debugprint($value,true);
			}
		}elseif(is_bool($message)){
			echo "boolean:";
		}elseif(is_null($message)){
//		}elseif(is_string($message)  ){
//		}elseif( is_numeric($message) ){
		}elseif(@unserialize($message)){  //the @ is to suppress the 'notice'
			echo $message." (Unserializing:)";
			debugprint(unserialize($message));	
		}else{
//			echo "<br>";
			echo $message."<br>".$filler;	
		}
		$printstack--;
	}
}

debugprint("debugprint Reached");

function sendquery($query){
	debugprint( "<br/> Sending query: $query ");
//	$query = mysql_real_escape_string($query);
	$result = mysql_query($query);
	if(!is_resource($result)) {
		debugprint("Query had no result to return. ");
		//failure can be checked if the type is boolean and value = 1,0, or null
		if(! isset($resource) and mysql_errno() != 0){  //some querys (like a delete) do not return a result.  instead, they set $resource
		//if(mysql_errno() != 0){
//			debugprint("<br/> Sending query: $query <br/>");
			debugprint("error: ". mysql_error() . "<br>" . mysql_errno());
		}
		return NULL;
	}
	return $result;
}

function createtable($tablename){

	  //check if table exists
	$query = "DESC $tablename;";
	$result = sendquery($query);
	//printresult($result);
	if (!$result) {
		//echo "CREATING TABLE $tablename";
		//create table
		$query = "CREATE TABLE $tablename (
			ID INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
			name VARCHAR(100)
		);";
		sendquery($query);
	}
}
function generateID($tablename){
	$query = "SELECT count(*) FROM $tablename"; 
	$result = sendquery($query);
	$row = mysql_fetch_row($result);
	return $row[0] + 1;

}
function incomingdump($array){
	$tablename="incomingdump";
	createtable("$tablename");

	$currentID = generateID($tablename);
	
	$query = "INSERT INTO $tablename (ID) VALUES('$currentID');";  //hopefully this isn't a huge performance hit
	sendquery($query);
	  foreach($array AS $key => $value){
		$query = "ALTER TABLE $tablename ADD $key VARCHAR(255);";  //hopefully this isn't a huge performance hit
		sendquery($query);
		$query = "UPDATE $tablename SET $key='$value' WHERE ID=$currentID";
		sendquery($query);
	  }
	  
	
}

function printresult($result,$tablename = false,$editable = true){
// print them one after another
	if(is_resource($result)){	
		echo "<table  cellpadding=1 border=1>";
		if($tablename){	
			$query1 = "SHOW COLUMNS FROM $tablename;";
			$result1 = sendquery($query1);
			echo "<tr>";
			while($columnnames = mysql_fetch_row($result1)) {
				echo "<td><b><center><font size='1'>";
				echo "<a href='".$_SERVER["PHP_SELF"]."?orderby=".$columnnames[0]."'>$columnnames[0]</a>";
				echo "</font></center></b></td>";
			}
			echo "</tr>";
		}	
		while($row = mysql_fetch_assoc($result)) {
			echo "<tr>
			<form style='height:.5em;' method='post' action='".$_SERVER["PHP_SELF"]."'>";
			
			$rowsize = sizeof($row);
			$id = NULL;
			$id = $row["ID"];
			if(!$id) $id = $row["id"];
			if(!$id){
				//fields will not be editable
				$editable = false;
			}
			
			foreach ($row as $columnname => $value){
//				echo "<td><font size='1'>". $row[$i]." </font></td>";
				echo "<td><input class='advancedsearch' type='text' name='".$id."_".$columnname."' value='";
				echo $value;
				echo "'></td>";
			}
			if($editable){
				//delete this row	button
				echo "<td>
				<input type='hidden' name='tablename' value='$tablename'>
				<input type='hidden' name='row' value='$id'>
				<input type='hidden' name='timestamp' value='".time()."'>
				<input type='submit' name='deleterowsubmit' value='delete row $id'></td>";
				
				//edit this row
				echo "<td>
				<input type='hidden' name='tablename' value='$tablename'>
				<input type='hidden' name='row' value='$id'>
				<input type='hidden' name='timestamp' value='".time()."'>
				<input type='submit' name='editrowsubmit' value='update row $id'></td>";
			}			
			
			echo"</form>";
			echo "</tr>";
		}
	
		echo "</table>";
		if($editable){  //add a new row button
			echo "<form style='float:left;margin:10;' name='form1' method='post'  action='".$_SERVER["PHP_SELF"]."'>
					<input type='hidden' name='tablename' value='$tablename'>
					<input type='hidden' name='timestamp' value='".time()."'>
					<input type='submit' name='addrowsubmit' value='Add a new row'>
				</form>";
			/*
			echo "<form name='form1' method='post'  action='".$_SERVER["PHP_SELF"]."'   onsubmit='return show_confirm()'>
				<input type='hidden' name='tablename' value='$tablename'>
				<input type='hidden' name='timestamp' value='".time()."'>
				<input type='submit' name='deletetablesubmit' value='Delete table: $tablename'><br/>
			</form>";
			*/
			echo "<form style='margin:10;' name='form1' method='post'  action='".$_SERVER["PHP_SELF"]."'   onsubmit='return show_confirm()'>
				<input type='hidden' name='tablename' value='$tablename'>
				<input type='hidden' name='timestamp' value='".time()."'>
				<input type='submit' name='truncatetablesubmit' value='Clear table: $tablename'><br/>
			</form>";
		}		
	}
	else{
		echo "result = $result, type: ".gettype($result)."<br/>";	
	}
}
function printDB($db){	
	//print EVERYTHING
	global $SETTINGS;
	$query = "SHOW TABLES FROM $db;";

	$result = sendquery($query);
	echo "<hr><center><h2>Database Administration</h2><br>List of Tables in ".$SETTINGS["mysql_database"].":";
	printresult($result,false,false);
	echo "</center><br>";
	$result = sendquery($query);
	while($row = mysql_fetch_row($result)) {
		$query2 = "select * from $row[0];";  //name of table
		$result2 = sendquery($query2);
		echo "<center><font size='+2'> $row[0]</font></center>";
		printresult($result2,$row[0]);
	}	
}
function isrefresh(){
//so refreshing doesn't rebuild .  Every form that uses this must add a hidden timestamp input
//like so:			<input type='hidden' name='timestamp' value='".time()."'>
	global $SETTINGS;
	if (var_to_str($SETTINGS["debug"]) == "true"){
		return false;
	}

	debugprint("<hr>session timestamp=".$_SESSION['timestamp']."   POST timestamp= ".$_POST['timestamp']);
	
	//if($_SESSION['timestamp'] != $_POST['timestamp']){
	if(($_SESSION['timestamp'] != $_POST['timestamp']) or (!$_POST['timestamp'])){
		debugprint("session != Post.  this means it shouldnt be a refresh");
		return false;
	}else{
		debugprint("It IS a Refresh!  Gasp!");
		return true;
	}
}
function sanitize($text){
	$text = trim($text);
	$text = strip_tags($text);
	////$text = htmlspecialchars($text);   //reference only
	$text = mysql_real_escape_string($text);
//	$stripme = array(';','"','','');  //just in case  //cannot do this and the mysql_escape
//	$text = str_replace($stripme,'',$text);  
	
	$text = iconv("UTF-8", 'UTF-8//IGNORE', $text);  //like right single quotes?
	
	 if((function_exists("get_magic_quotes_gpc") && //php 5 check
	 get_magic_quotes_gpc() ) || //if it's on
	 ini_get('magic_quotes_sybase'))  //or sybase is on (since it overrides everything else)
	 {
		$text = stripslashes($text);
	 }
	//if($text == "") $text=" ";  //since can't insert an empty string
	return $text;
}

global $SETTINGS;
if (isset($SETTINGS["debug"]) and (var_to_str($SETTINGS["debug"]) == "true")){
	//debugprint($SETTINGS);
	echo '<div ID="debugprintdiv">JS Debugging Messages<hr></div>';		
}

debugprint("Debugfunctions finished");


?>

<script type='text/javascript'>

function debugprint(string){
	//check if debugprintdiv exists (great name, i know)
	if(document.getElementById('debugprintdiv')){
		debugprintdiv = document.getElementById('debugprintdiv');
		debugprintdiv.innerHTML += string;
	}

}

</script>

